<template>
	<div class="d-inline-flex">
		<v-btn class="px-4" rounded @click="showConfirmationDialog = true" v-bind="$attrs">Create Key</v-btn>
		<confirm-dialog
			v-model="showConfirmationDialog"
			title="Create API Key"
			:error="hasError ? error : undefined"
			:loading="isLoading"
			:button="apiKey.length === 0 ? 'Generate Key' : 'I have saved my API key'"
			:showCancelButton="apiKey.length === 0 ? true : false"
			button-color="primary"
			persistent
			@cleanup="handleCleanup"
			@confirm="handleConfirmGenerate"
			content-class="api-key-create-dialog"
		>
			API keys grant full programmatic access to your account, anyone with access to it can act on your behalf. The
			generated API key will only be shown to you once and must be stored securely. If you aren't certain that you need
			an API key or are not ready to store it, do not proceed.

			<template #content-footer>
				<v-form ref="form" class="mt-4" v-if="apiKey.length === 0" @submit="handleConfirmGenerate">
					<label for="api-label" class="label">
						API Key Label
						<span class="error--text">*</span>
					</label>
					<v-text-field
						ref="labelRef"
						class="mt-1"
						id="api-label"
						v-model="label"
						placeholder="My API Key"
						:rules="[isNotEmpty('Please enter a label', true)]"
						single-line
						outlined
					/>
				</v-form>
				<div v-else>
					<div class="mt-4">
						<div class="label">API Key Label</div>
						<code class="body-2">
							{{ label }}
						</code>
					</div>

					<v-tooltip bottom>
						<template v-slot:activator="{ on, attrs }">
							<div class="mt-4">
								<div class="label">API Key</div>
								<code class="body-2" v-bind="attrs" v-on="on" @click="handleCopy">
									{{ apiKey }}
									<v-icon>{{ isCopied ? 'mdi-check' : 'mdi-content-copy' }}</v-icon>
								</code>
							</div>
						</template>
						<span>Click to copy to clipboard</span>
					</v-tooltip>
				</div>
			</template>
		</confirm-dialog>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import copy from 'clipboard-copy';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { useCreateApiKey } from '@/store/modules/apiKeys';
import { isNotEmpty } from '@/utils/rules';

export default defineComponent({
	components: { ConfirmDialog },
	inheritAttrs: false,
	setup(_, { root }) {
		const showConfirmationDialog = ref<boolean>(false);
		const form = ref();
		const label = ref<string>('');
		const apiKey = ref<string>('');
		const isCopied = ref<boolean>(false);
		const { createApiKey, clearError, isLoading, hasError, error: createError } = useCreateApiKey(root.$store);

		const error = computed<string>(
			() =>
				createError.value?.response?.data?.message ||
				'An error occurred while attempting to generate an API key. Please try again.'
		);

		const handleConfirmCopy = () => {
			showConfirmationDialog.value = false;
		};

		const handleConfirmGenerate = async (event: any) => {
			if (apiKey.value.length === 0) {
				event?.preventDefault();
				clearError();

				if (!form.value.validate()) {
					return;
				}

				apiKey.value = await createApiKey(label.value.trim());
			} else {
				handleConfirmCopy();
			}
		};

		const handleCopy = () => {
			isCopied.value = false;

			copy(apiKey.value)
				.then(() => {
					isCopied.value = true;
				})
				.finally(() => {
					setTimeout(() => {
						isCopied.value = false;
					}, 2500);
				});
		};

		const handleCleanup = () => {
			root.$store.dispatch('user/getUser');
			form.value?.reset();
			label.value = '';
			apiKey.value = '';
			isCopied.value = false;
			clearError();
		};

		return {
			showConfirmationDialog,
			label,
			apiKey,
			isCopied,
			handleConfirmGenerate,
			handleConfirmCopy,
			handleCopy,
			handleCleanup,
			isLoading,
			hasError,
			error,
			isNotEmpty,
			form,
		};
	},
});
</script>

<style lang="scss">
.v-dialog__content .api-key-create-dialog .v-card__text {
	code {
		width: 100%;
		position: relative;
		display: block;
		padding: 1rem 1.5rem 1rem 1rem;
		background-color: #e7e9eb;
		color: #000;
		word-break: break-all;

		&[role='button'] {
			cursor: pointer;
		}

		.v-icon {
			position: absolute;
			top: 1rem;
			right: 0.5rem;
		}
	}
}
</style>
